<template>
  <div class="crop">
    <div class="grid grid-rows-2 sm:grid-cols-2 lg:w-1/2 mx-auto mt-10 sm:mt-0">
      <p v-if="!selectedNotStandardSize" class="text-2xl text-white">Кадрирование {{`${size.w}x${size.h}`}}</p>
      <p v-else class="text-2xl text-white">{{valueSize.width}}x{{valueSize.height}} мм</p>
      <div @click="modalSelectSize = true" class="button">Указать другой размер</div>
    </div>
    <vue-cropper
      class="mt-2 img-container"
      ref="vueCropperRef"
      :src="imgSrc"
      alt="Source Image"
      v-bind="cropperOptions"
    />
    <div class="control mt-2">
      <div @click="cropperRotate" class="button primary horizontally" title="Повернуть">
        <span class="hidden sm:inline-block">Повернуть</span>
        <img width="15" class="ml-1 hidden sm:inline-block" src="../assets/images/icons/phone-rotate-landscape.png" alt="">
        <img width="24" class="sm:hidden" src="../assets/images/icons/phone-rotate-landscape.png" alt="Повернуть">
      </div>
      <div @click="crop" class="button primary" title="Применить">
        <span class="hidden sm:inline-block">Применить</span>
        <img width="24" class="sm:hidden" src="../assets/images/icons/check.png" alt="Применить">
      </div>
      <div @click="close" class="button primary" title="Отмена">
        <span class="hidden sm:inline-block">Отмена</span>
        <img width="24" class="sm:hidden" src="../assets/images/icons/close.png" alt="Отмена">
      </div>
    </div>
    <Modal v-if="modalSelectSize" @close="modalSelectSize = false">
      <template v-slot:body>
        <label>
          <span>Ширина</span>
          <input @keyup.enter="setSizeCrop" type="number" v-model="valueSize.width" placeholder="в миллиметрах">
        </label>
        <label>
          <span>Высота</span>
          <input @keyup.enter="setSizeCrop" type="number" v-model="valueSize.height" placeholder="в миллиметрах">
        </label>
        <div class="grid grid-rows-2 sm:grid-rows-1 sm:grid-cols-2 mx-auto mt-6 w-full">
          <div @click="modalSelectSize = false" class="button">Закрыть</div>
          <div @click="setSizeCrop" class="button">Применить</div>
        </div>
      </template>
    </Modal>
  </div>
</template>

<script>

import VueCropper from '@ballcat/vue-cropper';
// https://ballcat-projects.github.io/vue-cropper/
// https://github.com/fengyuanchen/cropperjs/blob/main/README.md#events
import Cropper from 'cropperjs'
import 'cropperjs/dist/cropper.css';
import {ref, reactive, watch, onMounted} from "vue";
import Modal from "./Modal.vue";

export default {
  name: "Crop",
  components: {
    Modal,
    'vue-cropper':VueCropper
  },
  props: {
    imgSrc: {
      required: true
    },
    size: {
      type: Object,
      required: true
    }
  },
  emits: ["cropImage", "close"],
  setup(prop, { emit }) {
    // настройки обрезки
    const cropperOptions = Cropper.Options = reactive({
      width: prop.size.w,
      height: prop.size.h,
      aspectRatio: prop.size.w / prop.size.h,
      viewMode: 0,
      responsive: true,
      restore: true,
      checkCrossOrigin: true,
      checkOrientation: true,
      modal: true,
      guides: true,
      center: true,
      highlight: true,
      background: true,
      autoCrop: true,
      movable: true,
      rotatable: true,
      scalable: true,
      zoomable: true,
      zoomOnTouch: true,
      zoomOnWheel: true,
      cropBoxMovable: true,
      cropBoxResizable: true,
      toggleDragModeOnDblclick: true
    })
    // положение облости кадрирования
    const horizontally = ref(true);
    // отсюда можно получать всякие функции обрезки
    const vueCropperRef = ref(null);
    // окно с указанием индивидуальных размеров
    const modalSelectSize = ref(false)
    // пользователь выбрал и указал нестандартный размер
    const selectedNotStandardSize = ref(false)
    // индвидуальные размеры
    const valueSize = reactive({
      width: null,
      height: null
    })

    // сохранение скадрованной фотки
    function crop () {
      vueCropperRef.value.getCroppedCanvas().toBlob((blob) => {
        emit('cropImage', {
          file: blob,
          width: valueSize.width,
          height: valueSize.height,
          notStandardSize: selectedNotStandardSize.value
        })
      }, 'image/jpg')
    }

    // поворот области кадрирования
    function cropperRotate() {
      if (horizontally.value && !valueSize.width) cropperOptions.aspectRatio = cropperOptions.width / cropperOptions.height
      else if (!horizontally.value && !valueSize.width) cropperOptions.aspectRatio = cropperOptions.height / cropperOptions.width
      else if (horizontally.value && valueSize.width) cropperOptions.aspectRatio = valueSize.height / valueSize.width
      else if (!horizontally.value && valueSize.width) cropperOptions.aspectRatio = valueSize.width / valueSize.height
      horizontally.value = !horizontally.value
    }

    // после указания размеров, при нажатии "применить" или "enter", установится нужные размеры и их соотношение сторон
    function setSizeCrop () {
      cropperOptions.width = valueSize.width
      cropperOptions.height = valueSize.height
      cropperOptions.aspectRatio = valueSize.width / valueSize.height
      modalSelectSize.value = false
      selectedNotStandardSize.value = true
    }

    // закрытие окна кадрирования, без внесения изменений
    function close() {
      emit('close')
    }

    watch(
      () => cropperOptions,
      () => console.log(cropperOptions),
      { deep: true },
    )
    onMounted(() => {
      // vueCropperRef.value.crop().detail.height
    });

    return {
      vueCropperRef,
      cropperOptions,
      horizontally,
      modalSelectSize,
      valueSize,
      selectedNotStandardSize,
      setSizeCrop,
      crop,
      cropperRotate,
      close
    };
  }
}
</script>

<style lang="scss">
.control {
  display: grid;
  grid-template-columns: 1fr 1fr 1fr;
  grid-column-gap: 10px;
  grid-row-gap: 1em;
  .button {
    font-size: 10px;
  }
}
.img-container {
  max-height: calc(100vh - 180px);
  min-height: calc(100vh - 180px);
  @media (max-width: 400px) {
    max-height: calc(100vh - 280px);
    min-height: calc(100vh - 280px);
  }
}
</style>
